diff --git a/src/child.c b/src/child.c
index 0c471261..befa3967 100644
--- a/src/child.c
+++ b/src/child.c
@@ -1147,10 +1147,11 @@ do_child_fork(int argc, char *argv[], int moni, bool launch)
     // propagate shortcut-inherited icon
     if (icon_is_from_shortcut)
       setenv("MINTTY_ICON", cs__wcstoutf(cfg.icon), true);
-    // provide environment to to maximize window
-    if (IsZoomed(wnd)) {
+    // provide environment to maximise window
+    if (win_is_fullscreen)
+      setenvi("MINTTY_MAXIMIZE", 2);
+    else if (IsZoomed(wnd))
       setenvi("MINTTY_MAXIMIZE", 1);
-    }
 
     //setenv("MINTTY_CHILD", "1", true);
 
diff --git a/src/winmain.c b/src/winmain.c
index 83a28113..32aa6620 100644
--- a/src/winmain.c
+++ b/src/winmain.c
@@ -4689,9 +4689,9 @@ main(int argc, char *argv[])
     monitor = atoi(getenv("MINTTY_MONITOR"));
     unsetenv("MINTTY_MONITOR");
   }
-  bool maximize = false;
+  int run_max = 0;
   if (getenv("MINTTY_MAXIMIZE")) {
-    maximize = !!atoi(getenv("MINTTY_MAXIMIZE"));
+    run_max = atoi(getenv("MINTTY_MAXIMIZE"));
     unsetenv("MINTTY_MAXIMIZE");
   }
 
@@ -5311,8 +5311,9 @@ main(int argc, char *argv[])
   // Determine how to show the window.
   go_fullscr_on_max = (cfg.window == -1);
   default_size_token = true;  // prevent font zooming (#708)
-  int show_cmd = (go_fullscr_on_max || maximize) ? SW_SHOWMAXIMIZED : cfg.window;
+  int show_cmd = (go_fullscr_on_max || run_max) ? SW_SHOWMAXIMIZED : cfg.window;
   show_cmd = win_fix_taskbar_max(show_cmd);
+  // if (run_max == 2) win_maximise(2); // do that later to reduce flickering
 
   // Scale to background image aspect ratio if requested
   win_get_pixels(&ini_height, &ini_width, false);
@@ -5327,6 +5328,9 @@ main(int argc, char *argv[])
   // Finally show the window.
   ShowWindow(wnd, show_cmd);
   SetFocus(wnd);
+  // Cloning fullscreen window
+  if (run_max == 2)
+    win_maximise(2);
 
   // Set up clipboard notifications.
   HRESULT (WINAPI * pAddClipboardFormatListener)(HWND) =
diff --git a/wiki/Changelog.md b/wiki/Changelog.md
index 2c1b14cd..2424d1d6 100644
--- a/wiki/Changelog.md
+++ b/wiki/Changelog.md
@@ -9,6 +9,7 @@ Keyboard handling
 Window handling
   * Search results are cleared on reset (#998).
   * Constrain dark mode handling (#983) to Windows 10 Version 1809 (#1001).
+  * Alt+F2 clones maximised and fullscreen window modes (#999, ~#633).
 
 Configuration
   * New user-definable function kb-select (#997, #84).
